package com.jpattern.orm.generator.reflection;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.ResultSet;

/**
 * set a value to a field
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public abstract class ASetFieldManipulator {

	private final Method resultSetGetterMethodString;
	private final Method resultSetGetterMethodInt;

	public ASetFieldManipulator(Method resultSetGetterMethodString, Method resultSetGetterMethodInt) {
		this.resultSetGetterMethodString = resultSetGetterMethodString;
		this.resultSetGetterMethodInt = resultSetGetterMethodInt;
	}

	public abstract void setValue(Object bean, Object value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;

	public final void setValueFromResultSet(Object bean, ResultSet rs, String rsColumnName) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setValue(bean, resultSetGetterMethodString.invoke(rs, rsColumnName)) ;
	}

	public final void setValueFromResultSet(Object bean, ResultSet rs, int rsColumnIndex) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		setValue(bean, resultSetGetterMethodInt.invoke(rs, rsColumnIndex)) ;
	}
}
