package com.jpattern.orm.generator.wrapper;

import java.math.BigDecimal;

/**
 * 
 * @author Francesco Cina'
 *
 * Apr 1, 2012
 */
public class ShortToBigDecimalWrapper implements TypeWrapper<Short, BigDecimal> {

	@Override
	public Class<BigDecimal> resultSetTypeToUse() {
		return BigDecimal.class;
	}

	@Override
	public Class<Short> wrapperClass() {
		return Short.class;
	}

	@Override
	public Short wrap(final BigDecimal value) {
		if (value==null) {
			return null;
		}
		return value.shortValue();
	}

	@Override
	public BigDecimal unWrap(final Short value) {
		if (value==null) {
			return null;
		}
		return BigDecimal.valueOf(value);
	}

}
